<?php 
    if(isset($_POST['nonce'])){
        $verify_nonce = wp_verify_nonce( $_POST['nonce'], 'fluent_forms-amocrm');
    }
    
    // удаляем кастомную форму
    if( isset($_POST['action']) and $_POST['action'] === 'delete_form' and isset($_POST['nonce']) and $verify_nonce ){
        wp_delete_post($_POST['custom_form_id'], true);
    }

    // удаляем лид
    if( isset($_GET['action']) and $_GET['action'] === 'delete_lead' and isset($_GET['lead_id']) and wp_verify_nonce( $_GET['nonce'], 'fluent_forms-amocrm') ){
        wp_delete_post($_GET['lead_id'], true);
    }

    // сохраняем настройки кастомной формы
    if( isset($_POST['action']) and $_POST['action'] === 'save_custom_form' and isset($_POST['nonce']) and $verify_nonce ){
        $_POST['fluent_forms-amocrm']['tags'] = isset($_POST['fluent_forms-amocrm']['tags']) ? $_POST['fluent_forms-amocrm']['tags'] : [];
        update_post_meta( $_POST['custom_form_id'], 'fluent_forms-amocrm', ($_POST['fluent_forms-amocrm']) );
    }
       
    // сохранем общие настройки плагина
    if( isset($_POST['action']) and $_POST['action'] === 'save_settings' and isset($_POST['nonce']) and $verify_nonce ){
        update_option( 'fluent_forms-amocrm', $_POST['fluent_forms-amocrm'], 'no' );
    }

    // обновляем данные из amoCRM
    if( isset($_GET['clear']) and $_GET['clear'] ){
        getAmoFields_forms_amocrm();
    }

    require_once (__DIR__ . '/fields_default.php');

    $amo_settings = get_option('fluent_forms-amocrm-settings');
    if( !$amo_settings ){
        $amo_settings = getAmoFields_forms_amocrm();
    }
    
    $amoFields = isset($amo_settings['fields']) ? $amo_settings['fields'] : ['0' => 'Поля не загружены'];
    $amoManagers = isset($amo_settings['managers']) ? $amo_settings['managers'] : ['0' => 'Ответственные не загружены'];

    if(isset($_GET['custom_form_id']) and $_GET['custom_form_id']){
        $form = get_fluentform($_GET['custom_form_id']);
        $get_post_meta = get_post_meta( $_GET['custom_form_id'], 'fluent_forms-amocrm', 1 );
        $fields = $get_post_meta ? ($get_post_meta) : [];
        $post_tags = (isset($fields['post_ID']) and $fields['post_ID'] !== '0') ? $custom_tags : $custom_tags_short;
        $all_tags = array_keys( $post_tags );
        $all_tags[] = 'order_id';
        $form_tags = array_keys(get_fluentform_fields($_GET['custom_form_id']));

        if($form_tags){
            foreach($form_tags as $form_field){
                $all_tags[] = $form_field;
            }
        }

        $amoPipelines = isset($amo_settings['pipelines']) ? $amo_settings['pipelines'] : ['0' => ['name' => 'Воронки не загружены']];
        $fields['task'] = isset($fields['status']) ? $fields['task'] : $task_default;
        $task_types = $amo_settings['task_types'];
        $note = isset($fields['note']) ? $fields['note'] : $note_default;
        $fields['status'] = isset($fields['status']) ? $fields['status'] : true;
        $fields['lead_name'] = isset($fields['lead_name']) ? $fields['lead_name'] : $lead_name_default;
        $fields['price'] = isset($fields['price']) ? $fields['price'] : 1000;
        $fields['pipeline_id'] = (!isset($fields['pipeline_id']) and $amoPipelines ) ? key($amoPipelines) : $fields['pipeline_id']; 
        $fields['responsible_list'] = !isset($fields['responsible_list'])  ? [] : $fields['responsible_list'];
        $fields['tags'] = isset($fields['tags']) ? $fields['tags'] : $tags_default;
        $required = isset($fields['required']) ? $fields['required'] : [];
        $title = $form['title'] .' :: Настройка формы';
        require_once (__DIR__ . '/templates/form_edit.php');
    }elseif( isset($_GET['lead_id']) and $_GET['lead_id'] ){
        $form = get_post($_GET['lead_id'], 'ARRAY_A');
        $form['id'] = $form['ID'];
        $title = 'Заявка #'.$form['ID'];
        require_once (__DIR__ . '/templates/lead_view.php');
    }else{
        $forms_custom = get_fluent_forms_amocrm();
        $leads = getLeads_forms_amocrm();
        $title = 'Интеграция с amoCRM';
        require_once (__DIR__ . '/templates/settings_page.php');
    }
?>
