<?php require_once (__DIR__ . '/header.php'); ?>
<form action="/wp-admin/options-general.php?page=fluent_forms-amocrm" method="post">
    <input type="hidden" name="action" value="save_settings">
    <input type="hidden" name="nonce" value="<?php echo wp_create_nonce('fluent_forms-amocrm'); ?>">
    <div class="wrap">
        <div class="card" style="max-width:100%">
            <h2 class="title">Мои формы</h2>
            <hr>
            <div class="row">
                <table class="wp-list-table widefat fixed striped table-view-list forms_amocrm">
                    <thead>
                        <tr>
                            <th scope="col" class="manage-column column-name column-primary desc">
                                <span>Название формы</span>
                            </th>
                            <th scope="col" id="shortcode" class="manage-column column-shortcode">Заявок</th>
                            <th scope="col" id="created" class="manage-column column-created desc">
                                <span>Создано</span>
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php if($forms_custom){ ?>
                            <?php foreach($forms_custom as $form){ ?>
                            <tr>
                                <td class=" column-name has-row-actions column-primary">
                                    <a href="/wp-admin/options-general.php?page=fluent_forms-amocrm&custom_form_id=<?= $form['id'] ?>" title="Настроить форму">
                                        <strong><?= $form['title'] ?></strong>
                                    </a>
                                </td>
                                <td class="shortcode column-shortcode"><?= get_leads_fluent_forms_amocrm($form['id']); ?></td>
                                <td class="created column-created"><?= $form['post_date'] ?></td>
                            </tr>
                            <?php } ?>
                        <?php } ?>
                    </tbody>
                </table>
            </div>
        </div>

        <div class="card" style="max-width:100%">
            <h2 class="title">Мои заявки</h2>
            <hr>
            <div class="row">
                <table class="wp-list-table widefat fixed striped table-view-list forms_amocrm leads_list">
                    <thead>
                        <tr>
                            <th scope="col" class="manage-column column-name column-primary desc">
                                <span>#</span>
                            </th>
                            <th scope="col" id="shortcode" class="manage-column column-shortcode">Форма</th>
                            <th scope="col" id="created" class="manage-column column-created desc">
                                <span>Создано</span>
                            </th>
                            <th scope="col" id="action" class="manage-column column-shortcode">Действие</th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php if($leads){ ?>
                            <?php foreach($leads as $lead){ ?>
                            <tr>
                                <td class=" column-name has-row-actions column-primary">
                                    <a href="/wp-admin/options-general.php?page=fluent_forms-amocrm&lead_id=<?= $lead['ID'] ?>" title="Настроить форму">
                                        <strong># <?= $lead['ID'] ?></strong>
                                    </a>
                                </td>
                                <td class="shortcode column-shortcode"><a href="/wp-admin/options-general.php?page=fluent_forms-amocrm&custom_form_id=<?= $lead['post_parent'] ?>"><?= get_the_title_fluentform($lead['post_parent']) ?></a></td>
                                <td class="created column-created"><?= $lead['post_date'] ?></td>
                                <td class="action column-created"> <span data-lead="<?= $lead['ID'] ?>">Удалить</span></td>
                            </tr>
                            <?php } ?>
                        <?php } ?>
                    </tbody>
                </table>
            </div>
        </div>
        <br>
        <button type="submit" class="button button-primary button-large">Сохранить настройки</button>

    </div>
</form>
<script>
    var pipelines = 0;
    var pipeline_id = 0;
    var pipeline_status = 0;
    var confirm_lang = 'Вы уверены?';
</script>

